<?php
/**
 *FILE NAME: STV.class.php
 *
 * Copyright (c) 2016 Miami University, All Rights Reserved.
 *
 * Miami University grants you ("Licensee") a non-exclusive, royalty free,
 * license to use, modify and redistribute this software in source and
 * binary code form, provided that i) this copyright notice and license
 * appear on all copies of the software; and ii) Licensee does not utilize
 * the software in a manner which is disparaging to Miami University.
 *
 * This software is provided "AS IS" and any express or implied warranties,
 * including, but not limited to, the implied warranties of merchantability
 * and fitness for a particular purpose are disclaimed. It has been tested
 * and is believed to work as intended within Miami University's
 * environment. Miami University does not warrant this software to work as
 * designed in any other environment.
 *
 * AUTHOR: Emily Schmidt
 *
 * DESCRIPTION:
 * STV Voting Calculation Class
 *
 * This class is responsible for calculating the results of an election using Wright
 * System STV (https://en.wikipedia.org/wiki/Wright_system).
 *
 * ENVIRONMENT DEPENDENCIES: PHP
 *
 * AUDIT TRAIL:
 *
 * DATE        UniqueID
 * 08/08/2016  schmidee  Initial File
 * 08/11/2016  schmidee  Correction for edge case where a person can win having zero
 * votes.
 * 08/17/2016  schmidee  Added in Warning return in the event of ties.
 * 09/09/2016  schmidee  Corrected Problem where ballots where not being ordered
 * correctly.
 */

namespace MiamiOH\FacultyElections\Services;

class STV
{
    private $debugMode = false;    //Turn on Debug Mode
    private $ballots;    //Condense Ballots
    private $numOfWinners;    //Number of Winners to Select
    private $nominees;    //List of all Nominees in the Election
    private $quota;    //Quota for being Declared a Winner
    private $numOfVoters;    //Total Number of Voters
    private $tempWinnerList;    //Temporary Winners List
    private $finalWinners;    //Final Winners List
    private $voteTally;    //Current Tally of Votes during Current Round
    private $removedNominees; //Array of Nomineees that should be removed prior to calculating STV
    private $warnings = array(); //Warnings generated by the STV Calculation.

    /**
     * STV constructor
     *
     * @param $ballots : Ballots for the Election (not condensed).
     * @param $numOfWinners : Number of winners that need to be selected.
     * @param $validNominees : All valid nominees in the election.
     * @param $removedNominees : Array of nominees that need to be removed.
     * @param $debug : Boolean for turning on Debug Statements.
     *
     * @throws \Exception
     */
    function __construct(
        $ballots,
        $numOfWinners,
        $validNominees,
        $removedNominees,
        $debug
    ) {
        if ($numOfWinners <= 0) {
            throw new \Exception("Number of winners must be larger than 0");
        } else {
            $this->numOfVoters = count($ballots);
            $this->ballots = $this->processData($ballots);
            $this->debugMode = $debug;
            $this->numOfWinners = $numOfWinners;
            $this->quota = -1;
            $this->tempWinnerList = array();
            $this->voteTally = array();
            $this->finalWinners = array();
            $this->removedNominees = $removedNominees;
            $this->warnings = array();
            //Set up Nominee Array
            foreach ($validNominees as $nom) {
                $this->nominees[$nom] = 0;
            }

            //Remove Nominees that need to be removed prior to the Election
            if (count($this->removedNominees) > 0) {
                foreach ($this->removedNominees as $nameOfNominee) {
                    $this->removeNominee($nameOfNominee);
                }

            }
        }
    }

    private function processData($data)
    {
        $tmp = $data;
        $ballots = array();
        $temp_nominees = array();

        $this->numOfVoters = count($tmp);

        foreach ($tmp as $row => $value) {
            $isFound = false;
            ksort($value);
            foreach ($ballots as &$ballot) {

                if ($this->array_equal($ballot['nominees'], $value)) {
                    $isFound = true;
                    $ballot['count']++;
                    $ballot['score']++;
                }
            }

            if (!$isFound) {
                array_push($ballots, array(
                    'count' => 1,
                    'score' => 1,
                    'index' => 0,
                    'nominees' => $value,
                ));
                $temp_nominees = array_merge($temp_nominees, $value);

            }
        }

        return $ballots;
    }

    private function array_equal($arr1, $arr2)
    {
        if (count($arr1) != count($arr2)) {
            return false;
        }
        foreach ($arr1 as $index => $value) {
            if (!isset($arr2[$index]) || $value != $arr2[$index]) {
                return false;
            }
        }

        return true;
    }

    /**
     * Set Ballots for STV Class
     *
     * @param $ballots : Ballots for the Election (not condensed).
     */
    public function setBallots($ballots)
    {
        $this->ballots = $this->processData($ballots);
    }

    /**
     * Set the Debug Mode for the STV Class
     *
     * @param $debug : Boolean in order to turn on debug statements.
     */
    public function setDebug($debug)
    {
        $this->debugMode = $debug;
    }

    /**
     * Set the removed Nominees for the STV Class
     *
     * @param $removedNominees : Array of nominees that need to be removed.
     */
    public function setRemovedNominees($removedNominees)
    {
        $this->removedNominees = $removedNominees;
    }


    /**
     * Set the number of winners for STV Class
     *
     * @param $numOfWinners : Number of winners that need to be selected.
     */
    public function setNumOfWinners($numOfWinners)
    {
        $this->numOfWinners = $numOfWinners;
    }

    /**
     * Get the Warnings from STV Class
     *
     * @return array containing warning messages from STV Calcuation.
     */
    public function getWarnings()
    {
        return $this->warnings;
    }

    /**
     * Calcuate STV Voting Results for a given Election
     *
     * @return array consisting of a key value pair where the winner is listed as
     *     the key and the value is is the number of votes the winner received.
     */
    public function calculate_stv()
    {
        $this->display('==============================Config==============================');
        $this->display("numOfWinners: ", $this->numOfWinners);
        $this->display("nominees: ", $this->nominees);
        $this->display("numOfVoters: ", $this->numOfVoters);
        $this->display('==============================Start Counting==============================');

        if ($this->numOfVoters <= 0) {
            //No one voted or No Winners need to be selected.
            throw new \Exception ("No Ballots Casted");
        }

        if (count($this->nominees) <= $this->numOfWinners) {
            //We already have enough winners or too many winners to nominees
            $this->runRound();
            $this->finalWinners = $this->voteTally;
            asort($this->finalWinners);

            return $this->finalWinners;
        }

        //Repeat STV Logic until enough winners are selected or nominees left equal number of winners
        for ($i = 0; count($this->nominees) > $this->numOfWinners; $i++) {
            //Recalculate Quota in case Exhausted Ballots Occurred
            $this->quota = floor(($this->numOfVoters / ($this->numOfWinners + 1))) + 1;

            $this->display("### Start Round: #", $i);
            $this->display('Start Round: #', $i);
            $this->display("Ballots:", $this->ballots);
            $this->display("numberOfVoters: ", $this->numOfVoters);
            $this->display("Recalculated Quota: ", $this->quota);

            //Run the round
            $this->runRound();

            //Check for Enough Winners
            if (count($this->tempWinnerList) >= $this->numOfWinners) {
                //Got Enough Winners, End election
                break;
            } else {
                //Got To Remove a Nominee due to not enough winners
                $this->findLoser();
            }

            if (count($this->nominees) == $this->numOfWinners) {
                //We have our Winners get accurate final scores
                $this->display("We have enough Nominees to be Winners after removal of Loser");

                //Rerun Round to get Final Votes Tallies
                $this->resetForNextRound();
                $this->runRound();
                break;
            } else {
                //No Winners reset for next round
                $this->resetForNextRound();
            }

        }
        //Winners Found
        $this->display("Vote Tally At End: ", $this->voteTally);
        $this->display("Winner List at End: ", count($this->tempWinnerList));

        if (count($this->tempWinnerList) == 0) {
            //Nominees Left are the Winners
            $this->finalWinners = $this->voteTally;
        } else {
            //Winners are in the tempWinnerList
            foreach ($this->tempWinnerList as $nominee) {
                //Winners were found add them to the list
                $this->finalWinners[$nominee] = $this->voteTally[$nominee];
            }
        }

        //Sort Winnters by Highest to Lowest Votes.
        arsort($this->finalWinners);
        //Return Winners
        $this->display($this->finalWinners);

        return $this->finalWinners;
    }

    /**
     * Helper Function to Display Error Logs when debug is set to True.
     */
    private function display()
    {
        if ($this->debugMode) {
            $args = func_get_args();
            echo '';
            foreach ($args as $arg) {
                if (is_string($arg)) {
                    echo " {$arg}";
                } else {
                    print_r($arg);
                }
            }
            echo "\n";
        }
    }

    private function removeNominee($nameOfNominee)
    {
        //Remove Nominee from Nominee List
        unset($this->nominees[$nameOfNominee]);

        //Remove Nominee from All Ballots
        foreach ($this->ballots as $key => &$ballot) {
            $ballot['nominees'] = array_diff($ballot['nominees'],
                array($nameOfNominee));
            if (count($ballot['nominees']) == 0) {
                //Ballot is Exhausted
                $this->display("Exhausted Ballot: ", $ballot['index']);
                $this->numOfVoters -= $ballot['count'];
                unset($this->ballots[$key]);
            }
            $ballot['nominees'] = array_values($ballot['nominees']);

        }


    }

    /**
     * Run a Round for STV
     */
    private function runRound()
    {

        //Initialize Vote Tally Array
        foreach ($this->nominees as $nominee => $nothing) {
            $this->voteTally[$nominee] = 0;
        }

        //Count First Ballots
        foreach ($this->ballots as $ballot) {
            if (isset($ballot['nominees'][$ballot['index']])) {
                $this->voteTally[$ballot['nominees'][$ballot['index']]] += $ballot['count'];
            }
        }

        //Sort Vote tally in Order of Highest to Lowest Votes
        arsort($this->voteTally);

        $this->display("Vote Tally:", $this->voteTally);

        //Check to see if we still have more Nominees than Winners
        if (count($this->voteTally) > $this->numOfWinners) {
            //Check for Over Quota canidates and Transfer their Votes Accordingly
            $transferOccured = $this->transferOverQuotaVotes($this->voteTally);

            //Check that a vote transfer occured and we still do not have enough winners
            while ($transferOccured && count($this->tempWinnerList) < $this->numOfWinners) {
                //Check for Over Quota canidates and Transfer their Votes Accordingly
                $transferOccured = $this->transferOverQuotaVotes();
            }

            //All Transfers have occured and we are at a stalemate
            arsort($this->voteTally);
        }

    }


    /**
     * Transfer Qver Quota Votes if they Exist
     *
     * @return bool: True of a Transfer occurred, false if a transfer didn't occur.
     */
    private function transferOverQuotaVotes()
    {
        //Sort Votes by Highest to Lowest
        arsort($this->voteTally);
        $transferOccured = false;
        $this->tempWinnerList = array();

        foreach ($this->voteTally as $nominee => $count) {
            if ($count >= $this->quota && count($this->tempWinnerList) < $this->numOfWinners) {
                //Found Nominee Over Quota
                array_push($this->tempWinnerList, $nominee);
            } else {
                //No More Nominees Over Quota or we have enough winners selected.
                break;
            }
        }

        if (count($this->tempWinnerList) < $this->numOfWinners && count($this->tempWinnerList) != 0) {
            //Still Not Enough Winners, Attempt to Transfer Nominee with Most Votes

            //We can guarantee that the first nominee in the list has the highest votes.
            $canidateToTransfer = array_shift($this->tempWinnerList);

            if ($this->voteTally[$canidateToTransfer] > $this->quota) {
                //Perform Transfer of Votes for Highest Canidate
                $this->display($this->voteTally[$canidateToTransfer]);
                //Calculate Score of Votes that are transfered (totalNumberOfVotesForNominee - Quota/ totalNumberOfVotesForNominee)
                $score = ($this->voteTally[$canidateToTransfer] - $this->quota) / floatval($this->voteTally[$canidateToTransfer]);
                $this->transferVote($canidateToTransfer, $score);

                //Set the transfer candidate to quota since their over quota votes were move to other candidates.
                $this->voteTally[$canidateToTransfer] = $this->quota;

                //State Transfers Occured During the Check for Over Quota
                $transferOccured = true;
            }
        }

        $this->display("Vote Tallies After Transfer: ", $this->voteTally);

        return $transferOccured;

    }

    /**
     * Transfer Votes from Nominee to other candidates with a vote value equal to
     * the score.
     *
     * @param $uid : ID of the Candidate who votes need to be transferred to other
     *     candidates.
     * @param $score : The value of the vote that are to be transferred (range from
     *     1 to 0)
     */
    private function transferVote($uid, $score)
    {
        $this->display("Transfering Votes: ", $uid, ", Transfer Score: ", $score);
        foreach ($this->ballots as &$ballot) {

            //Ballot Isn't a Vote for the Person needing to be Transfered
            if (!isset($ballot['nominees'][$ballot['index']]) || $ballot['nominees'][$ballot['index']] != $uid) {
                continue;
            }
            //Move to Next Non-Winner Vote in List
            do {
                $ballot['index']++;
            } while (isset($ballot['nominees'][$ballot['index']]) && in_array($ballot['nominees'][$ballot['index']],
                $this->tempWinnerList));

            if (!isset($ballot['nominees'][$ballot['index']])) {
                //Exhausted Ballot
                continue;
            } else {
                //Add in Transfer votes
                $this->display("Transfering Votes to: ",
                    $ballot['nominees'][$ballot['index']]);
                $this->voteTally[$ballot['nominees'][$ballot['index']]] += $ballot['count'] * $score;
            }

        }
        $this->display("Number of Voters After Transfer: ", $this->numOfVoters);
    }

    /**
     * Find a Loser and Remove them from the Nomination List
     */
    private function findLoser()
    {
        //Sort Votes in Lowest to Highest
        asort($this->voteTally);

        $tiedLosers = array();
        $previousCount = -1;

        //Determine all Losers who have the Lowest number of votes
        foreach ($this->voteTally as $nominee => $count) {
            if ($previousCount != -1) {
                if ($previousCount != $count) {
                    //No more Losers
                    $this->display("No More Losers: ", $previousCount);
                    break;
                } else {
                    //Tied Loser
                    $this->display("Loser Found: ", $nominee);
                    array_push($tiedLosers, $nominee);
                }
            } else {
                //Initizalize Previous Count
                $previousCount = $count;
                array_push($tiedLosers, $nominee);
            }
        }

        //Pick Random Loser
        $randomLoser = $tiedLosers[array_rand($tiedLosers)];
        $this->display("Loser: ", $randomLoser);

        if (count($tiedLosers) > 1) {
            array_push($this->warnings,
                "Random Loser had to be selected from the following: " . (implode($tiedLosers,
                    ', ')) . ". Loser Selected was $randomLoser");
        }

        //Remove Nominee from All Ballots
        $this->removeNominee($randomLoser);


    }

    /**
     * Rest globals for a new Round
     */
    private function resetForNextRound()
    {
        foreach ($this->ballots as &$ballot) {
            $ballot['index'] = 0;
            $ballot['nominees'] = array_values($ballot['nominees']);
        }

        $this->voteTally = array();

        $this->tempWinnerList = array();

    }
}
//}
